//this module implements a Single Port Distributed Ram
// RAM is inferred and this depends STRONGLY on the syntax.

`include "define.v"

module spdistram_v (clk, we, a, di, do); 
 
 input        clk; 
 input        we; 
 input  [`INPUT_LUT_ADDR_WIDTH - 1 :0] a; 
 input  [`INPUT_LUT_DATA_WIDTH - 1:0] di; 
 output [`INPUT_LUT_DATA_WIDTH - 1:0] do; 
 
 reg    [`INPUT_LUT_DATA_WIDTH - 1:0] ram [`INPUT_LUT_DEPTH - 1:0]; 
 
 always @(posedge clk) begin 
 	if (we) 
 		ram[a] <= di; 
 end 
 
 assign do = ram[a]; 
 
 endmodule

