//---------------------------------------------------------
// Description : 2-input 18-bit mux, with registred output 
//---------------------------------------------------------
`timescale 1ns / 1ps

module mux18 
  ( ck,  sel,  Din_One,  Din_Zero,  Mux_Out     );
  
  input   ck,  sel;
  input [17:0]   Din_One, Din_Zero;
  output[17:0]   Mux_Out;    reg   [17:0]   Mux_Out; 
  
  always@(posedge ck) 
    case(sel)
      1'b0: Mux_Out <= Din_Zero;
      1'b1: Mux_Out <= Din_One;
    endcase  
endmodule

